<ng-template #UserConfiguration let-userLevelThread="userLevelThread" let-kernelLevelThread="kernelLevelThread">
  <div class="thread-container">
    <div>
      <label for="processNameUser">{{ 'scheduling.threads.name' | translate }} </label>
      <input
        id="processNameUser"
        class="form-control-sm small-custom-element"
        [(ngModel)]="userLevelThread.name"
        placeholder="name"
        (ngModelChange)="diagram.updateCorrectionStatus()"
        required
      />
    </div>
    <div>
      <label for="processCTUser">{{ 'scheduling.threads.computingtime' | translate }} </label>
      <input
        id="processCTUser"
        type="number"
        [(ngModel)]="userLevelThread.computingTime"
        min="{{ userLevelThread.minComputingTime }}"
        max="{{ maxComputingTime }}"
        onkeydown="return false"
        (ngModelChange)="changeComputingTime($event, userLevelThread)"
        class="form-control-sm tiny-custom-element"
      />
    </div>

    <div>
      <label for="processATUser">{{ 'scheduling.threads.arrivaltime' | translate }}</label>
      <input
        id="processATUser"
        type="number"
        [(ngModel)]="userLevelThread.startTime"
        min="0"
        max="{{ maxStartingTime }}"
        onkeydown="return false"
        (ngModelChange)="changeStartingTime($event, userLevelThread, kernelLevelThread)"
        class="form-control-sm tiny-custom-element"
      />
    </div>

    <div *ngIf="userLevelThread.deadline != -1">
      <label for="processDeadlineUser">{{ 'scheduling.threads.deadline' | translate }}:</label>
      <input
        id="processDeadlineUser"
        type="number"
        [(ngModel)]="userLevelThread.deadline"
        min="{{ userLevelThread.startTime + 1 }}"
        onkeydown="return false"
        (ngModelChange)="changeDeadline($event, userLevelThread, kernelLevelThread)"
        class="form-control-sm tiny-custom-element"
      />
    </div>

    <div
      *ngIf="
        diagram.strategy == Strategies.Priority ||
        kernelLevelThread.userStrategy == Strategies.Priority ||
        diagram.strategy == Strategies.Priority_dynamic ||
        kernelLevelThread.userStrategy == Strategies.Priority_dynamic
      "
    >
      <label for="processPriorityUser">{{ 'scheduling.threads.prio.label' | translate }}:</label>
      <input
        id="processPriorityUser"
        type="number"
        [(ngModel)]="userLevelThread.priority"
        class="form-control-sm tiny-custom-element"
        onkeydown="return false"
        (ngModelChange)="diagram.updateCorrectionStatus()"
      />
    </div>

    <div *ngIf="userLevelThread.IOInterruptionActivated">
      <label for="processIOLengthUser">{{ 'scheduling.threads.io.length' | translate }}</label>
      <input
        id="processIOLengthUser"
        type="number"
        [(ngModel)]="userLevelThread.ioLength"
        min="1"
        max="{{ maxIOLength }}"
        onkeydown="return false"
        class="form-control-sm tiny-custom-element"
        (ngModelChange)="diagram.updateCorrectionStatus()"
      />
    </div>

    <div *ngIf="userLevelThread.IOInterruptionActivated">
      <label for="processIOAfterNUser">{{ 'scheduling.threads.io.after' | translate }}</label>
      <input
        id="processIOAfterNUser"
        type="number"
        [(ngModel)]="userLevelThread.ioAftern"
        min="1"
        max="{{ userLevelThread.computingTime - 1 }}"
        onkeydown="return false"
        (ngModelChange)="changeIOAfterN($event, userLevelThread)"
        class="form-control-sm tiny-custom-element"
      />
    </div>

    <button
      *ngIf="diagram.advancedConfigurationOptions && diagram.strategy != Strategies.EDF"
      type="button"
      class="btn btn-secondary btn-sm"
      (click)="toggleDeadline(userLevelThread)"
    >
      <fa-icon *ngIf="userLevelThread.deadline != -1" [icon]="faMinus"></fa-icon>
      <fa-icon *ngIf="userLevelThread.deadline == -1" [icon]="faPlus"></fa-icon>

      {{ 'scheduling.threads.deadline' | translate }}
    </button>

    <button
      *ngIf="diagram.advancedConfigurationOptions"
      type="button"
      class="btn btn-secondary btn-sm"
      (click)="addIOInterruption(userLevelThread)"
    >
      <fa-icon *ngIf="userLevelThread.IOInterruptionActivated" [icon]="faMinus"></fa-icon>
      <fa-icon *ngIf="!userLevelThread.IOInterruptionActivated" [icon]="faPlus"></fa-icon>
      {{ 'scheduling.threads.io.label' | translate }}
    </button>

    <button (click)="deleteThread(userLevelThread, kernelLevelThread)" type="button" class="btn btn-danger btn-sm">
      <fa-icon [icon]="faMinus"></fa-icon>
      {{ 'scheduling.threads.delete' | translate }}
    </button>
  </div>
</ng-template>

<div class="container scheduler-segment">
  <h1>{{ 'scheduling.threads.headline' | translate }}</h1>

  <div class="rightFloat">
    <button
      (click)="addKernelLevelThread()"
      type="button"
      class="btn btn-primary"
      [disabled]="maxNumberOfThreads < diagram.allUserLevelThreads.length"
    >
      <fa-icon [icon]="faPlus"></fa-icon>
      Kernel-Level-Thread
    </button>
    <button class="btn btn-secondary" (click)="toggleHelp()">
      <fa-icon [icon]="faQuestion"></fa-icon>
      {{ 'scheduling.diagram.help' | translate }}
    </button>
  </div>

  <div *ngIf="showHelp" class="alert alert-dismissible alert-secondary textwithnewline">
    <button type="button" class="btn-close" (click)="toggleHelp()"></button>
    <h4 class="alert-heading">{{ 'scheduling.threads.helpHeading' | translate }}</h4>
    {{ 'scheduling.threads.helpBody' | translate }}
  </div>

  <div *ngFor="let kernelLevelThread of kernelLevelThreads; let k = index" style="clear: both">
    <div *ngIf="kernelLevelThread.userLevelThreadsOfKernelThread[0].id != -1">
      <!-- left control elements-->
      <span class="float-child-button">
        <button
          (click)="addUserLevelThread(kernelLevelThread)"
          [disabled]="maxNumberOfThreads < diagram.allUserLevelThreads.length"
          class="btn btn-primary btn-sm configelement"
        >
          <fa-icon [icon]="faPlus"></fa-icon> User-Level-Thread
        </button>
        <button
          *ngIf="!(kernelLevelThread.userLevelThreadsOfKernelThread.length === 1)"
          (click)="deleteKernelLevelThread(kernelLevelThread)"
          class="btn btn-danger btn-sm configelement"
        >
          <fa-icon [icon]="faMinus"></fa-icon> Kernel-level-Thread
        </button>

        <select
          *ngIf="
            diagram.ownUserLevelScheduler &&
            diagram.strategy == Strategies.RR &&
            !(kernelLevelThread.userLevelThreadsOfKernelThread.length === 1)
          "
          class="form-control configelement"
          [(ngModel)]="kernelLevelThread.userStrategyHelper"
          (ngModelChange)="updateUserStrategy($event, kernelLevelThread)"
          name="chooseStrategie"
          id="field_chooseUserLevelStrategy"
        >
          <option value="{{ Strategies.FCFS }}">
            {{ 'scheduling.config.strategyDescription.fcfstitle' | translate }}
          </option>
          <option value="{{ Strategies.SJF }}">
            {{ 'scheduling.config.strategyDescription.sjftitle' | translate }}
          </option>
          <option value="{{ Strategies.SRTN }}">
            {{ 'scheduling.config.strategyDescription.srtntitle' | translate }}
          </option>
          <option value="{{ Strategies.Priority }}">
            {{ 'scheduling.config.strategyDescription.priotitle' | translate }}
          </option>
          <option value="{{ Strategies.EDF }}">
            {{ 'scheduling.config.strategyDescription.edftitle' | translate }}
          </option>
          <option value="{{ Strategies.RR }}">{{ 'scheduling.config.strategyDescription.rrtitle' | translate }}</option>
        </select>
      </span>

      <!-- Threads -->
      <div class="float-child-thread">
        <div *ngIf="kernelLevelThread.userLevelThreadsOfKernelThread.length === 1; else userOption">
          <ng-template
            *ngTemplateOutlet="
              UserConfiguration;
              context: {
                userLevelThread: kernelLevelThread.userLevelThreadsOfKernelThread[0],
                kernelLevelThread: kernelLevelThread
              }
            "
          >
          </ng-template>
        </div>

        <!-- The Kernellevel Thread contains more than one UserLevel Thread-->
        <ng-template #userOption>
          <div *ngFor="let userLevelThread of kernelLevelThread.userLevelThreadsOfKernelThread; let i = index">
            <ng-template
              *ngTemplateOutlet="
                UserConfiguration;
                context: { userLevelThread: userLevelThread, kernelLevelThread: kernelLevelThread }
              "
            >
            </ng-template>
          </div>
        </ng-template>

        <div
          *ngIf="
            kernelLevelThread.userStrategy == Strategies.Priority ||
            kernelLevelThread.userStrategy == Strategies.Priority_dynamic ||
            kernelLevelThread.userStrategy == Strategies.EDF ||
            kernelLevelThread.userStrategy == Strategies.RR
          "
          class="additionalSettingsContainer"
        >
          <!-- Special Userlevel Scheduling options -->
          <div class="float-child-userbutton">
            <div *ngIf="kernelLevelThread.userStrategy == Strategies.RR" class="form-check form-switch">
              <input
                class="form-check-input"
                id="arrivalTimeOrderRR"
                name="prioritySpecificationKernel"
                type="checkbox"
                [value]="false"
                [(ngModel)]="kernelLevelThread.userlevelSchedulerArrivalTimeRR"
                (ngModelChange)="diagram.updateCorrectionStatus()"
              />
              <label class="form-check-label" for="preemptiveSpecificationKernel">{{
                'scheduling.threads.rr.arrivallabel' | translate
              }}</label>
            </div>
            <div
              *ngIf="
                kernelLevelThread.userStrategy == Strategies.Priority ||
                kernelLevelThread.userStrategy == Strategies.Priority_dynamic ||
                kernelLevelThread.userStrategy == Strategies.EDF
              "
              class="form-check form-switch"
            >
              <input
                class="form-check-input"
                id="preemptiveSpecificationKernel"
                name="prioritySpecificationKernel"
                type="checkbox"
                [value]="false"
                [(ngModel)]="kernelLevelThread.userSchedulingPreemptive"
                (ngModelChange)="diagram.updateCorrectionStatus()"
              />
              <label class="form-check-label" for="preemptiveSpecificationKernel">{{
                'scheduling.threads.prio.preemptive' | translate
              }}</label>
            </div>
            <div
              *ngIf="
                kernelLevelThread.userStrategy == Strategies.Priority ||
                kernelLevelThread.userStrategy == Strategies.Priority_dynamic
              "
              class="form-check form-switch"
            >
              <input
                class="form-check-input"
                id="dynamicprioritySpecificationKernel"
                name="prioritySpecificationKernel"
                type="checkbox"
                [value]="true"
                [(ngModel)]="kernelLevelThread.userStrategyDynamic"
                (ngModelChange)="diagram.updateCorrectionStatus(); updateUserStrategyDynamic($event, kernelLevelThread)"
              />
              <label class="form-check-label" for="dynamicprioritySpecificationKernel">{{
                'scheduling.threads.prio.dynamic' | translate
              }}</label>
            </div>
            <div
              *ngIf="
                kernelLevelThread.userStrategy == Strategies.Priority ||
                kernelLevelThread.userStrategy == Strategies.Priority_dynamic
              "
              class="form-check form-switch"
            >
              <input
                class="form-check-input"
                id="lowPrioritySpecificationKernel"
                name="priorityOrderSpecificationKernel"
                type="checkbox"
                checked
                [value]="false"
                [(ngModel)]="kernelLevelThread.lowestPriorityFirstKernel"
                (ngModelChange)="diagram.updateCorrectionStatus()"
              />
              <label class="form-check-label" for="dynamicprioritySpecificationKernel">{{
                'scheduling.threads.prio.lowestfirst' | translate
              }}</label>
            </div>
          </div>

          <div class="float-child-userthread" *ngIf="kernelLevelThread.userStrategy == Strategies.Priority_dynamic">
            <div class="rightFloat">
              <label for="input_priochangeComputingKernel">{{
                'scheduling.config.dynamiccomputing.label' | translate
              }}</label>
              <input
                id="input_priochangeComputingKernel"
                type="number"
                class="form-control-sm tiny-custom-element"
                [(ngModel)]="kernelLevelThread.prioChangeComputingKernel"
                step="0.1"
                (ngModelChange)="diagram.updateCorrectionStatus()"
              />
            </div>
            <div class="rightFloat">
              <label for="input_priochangeWaitingKernel">{{
                'scheduling.config.dynamicwaiting.label' | translate
              }}</label>
              <input
                id="input_priochangeWaitingKernel"
                type="number"
                class="form-control-sm tiny-custom-element"
                onkeydown="return false"
                [(ngModel)]="kernelLevelThread.prioChangeWaitingKernel"
                step="0.1"
                (ngModelChange)="diagram.updateCorrectionStatus()"
              />
            </div>
          </div>
          <div *ngIf="kernelLevelThread.userStrategy == Strategies.RR" class="float-child-userthread">
            <label for="userlevelTimeSliceLengthInput">{{
              'scheduling.config.timeslicelength.label' | translate
            }}</label>
            <input
              id="userlevelTimeSliceLengthInput"
              type="number"
              [(ngModel)]="kernelLevelThread.userlevelTimeSliceLength"
              min="1"
              class="form-control-sm tiny-custom-element"
              onkeydown="return false"
              (ngModelChange)="diagram.updateCorrectionStatus()"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
  <div style="text-align: center; color: grey" *ngIf="kernelLevelThreads.length <= 1">
    <br />
    {{ 'scheduling.threads.info' | translate }}
  </div>
</div>
